Attribute VB_Name = "modMigration"
Option Explicit
Option Base 0

'*** define global variables ***
Global glPosLeft As Long          'Left Position of Screen
Global glPosTop As Long           'Top Position of Screen
Global gsPath As String           'Path Selected
Global gbShowFirst As Boolean     'True  : When Program Run At The First Time
                                  'False : Else
Global gbODBCOpened As Boolean    'True  : ODBC Opened
                                  'False : Else
Global fMgr As Integer            'Text File Number
Global sTextFile As String        'Text File Name
Global sFTextFile As String       'Full Text File Name
Global lMaxRow As Long            'The Rows Of Text File
Global lMaxLen As Long            'The Max Length Of Text File Record
Global sDelimited As String * 1   'The Delimited Char Of Text File
Global bFirstRow As Boolean       'True  : First Row is Head
                                  'False : Else
Global gbDBType As Integer        '1 : XBase
                                  '2 : Text
                                  '3 : Access
Global gbVFPDBC As Boolean        'True  : Visual Foxpro DBC
                                  'False : General xBase File
Global gbTextType As Boolean      'True  : Select Delimited Char
                                  'False : Constant Column Length

Global giFile As Integer
Global nStart As Integer
Global nEnd As Integer
Global prpSrc As DAO.Property
Global nNodes As Integer
Global nAction As Integer
Global bSuccess As Boolean
Const SQL_NTS As Long = -3
Const SQL_DROP As Long = 1

'*** define array variables ***
Global aryVBType(23) As String   'VB data type
Global aryType(23) As Integer    'VB mapping to DBMaker
Global aryCvtLen(23) As Integer  'VB Length
Global aryDot(23) As Integer     'VB Scale
Global aryDBMaker(13) As String  'DBMaker data type
Global aryDBMSize(13) As String  '0 : no need precision & scale
                                 '1 : need size only
                                 '2 : need precision & scale
Global aryOTextFile() As String  'The Original Text File Name
Global aryOTextCol() As String   'The Original Text File Column Name
Global aryTextDlm() As Long      'The every column length after delimiting
Global arySpace() As Long
Global aryRmv() As Long

Global aryTableSrc() As String
Global aryTableMgr() As String
Global aryColMgr() As String
Global aryTypeMgr() As Integer
Global aryLenMgr() As Integer
Global aryDotMgr() As Integer
Global aryTblColsMgr() As Integer
Global nTableSel As Integer
Global lRows As Long

'*** define file name relative variables ***
Global strFileSubName As String
Global strFileName As String

'*** define DAO relative variables ***
Global dbdBase As Database
Global dbParadox As Database
Global dbVFPDBC As Database
Global dbTexts As Database
Global dbSource As Database
Global tbSource As TableDef
Global rsSource As Recordset
Global dbAccess As Database

'*** define RDO relative variables ***
Global enTarget As rdoEnvironment
Global dbTarget As rdoConnection

'*** ]wDBMakerƫO` ***
Global Const DBMakerTypes = 13
Global Const DBMUnknow = 0
Global Const DBMBinary = 1
Global Const DBMChar = 2
Global Const DBMDate = 3
Global Const DBMDecimal = 4
Global Const DBMDouble = 5
Global Const DBMFloat = 6
Global Const DBMInteger = 7
Global Const DBMLongVarbinary = 8
Global Const DBMLongVarChar = 9
Global Const DBMSmallInt = 10
Global Const DBMTime = 11
Global Const DBMTimeStamp = 12
Global Const DBMVarChar = 13

Declare Function SQLAllocEnv% Lib "ODBC32.DLL" (env&)
Declare Function SQLAllocStmt% Lib "ODBC32.DLL" (ByVal hdbc&, stmt&)
Declare Function SQLFreeStmt% Lib "ODBC32.DLL" (ByVal stmt&, ByVal opt%)
Declare Function SQLDataSources% Lib "ODBC32.DLL" (ByVal henv&, ByVal fdir%, ByVal szDSN$, ByVal cbDSNMax%, pcbDSN%, ByVal szDesc$, ByVal cbDescMax%, pcbDesc%)
Declare Function SQLExecDirect% Lib "ODBC32.DLL" (ByVal hdbc&, ByVal sql$, ByVal sqllen%)
Declare Function SQLSetConnectOption% Lib "ODBC32.DLL" (ByVal hdbc&, ByVal opt%, ByVal value%)


Sub Main()
  '*** ]w{l ***
  gbShowFirst = True
  gbODBCOpened = False
  gbDBType = 1
  gsPath = ""
  Set enTarget = rdoEngine.rdoEnvironments(0)
  
  '*** ]wƫOഫx} ***
  TypeConvert
  frmMain.Show
End Sub

Function Confirm()
  Confirm = MsgBox("O_Tw", vbYesNo + vbQuestion, "}")
End Function

Sub ShowAbout(frmLeft As Long, frmTop As Long, frmWidth As Long, frmHeight As Long)
  frmAbout.Left = frmLeft + (frmWidth - frmAbout.Width) / 2
  frmAbout.Top = frmTop + (frmHeight - frmAbout.Height) / 2
  frmAbout.Show vbModal
End Sub

Sub TypeConvert()
  Dim i As Integer
  
  '*** ]wVBƫOx} ***
  aryVBType(1) = "Boolean"          'dbBoolean    =  1
  aryVBType(2) = "Byte"             'dbByte       =  2
  aryVBType(3) = "Integer"          'dbInteger    =  3
  aryVBType(4) = "Long"             'dbLong       =  4
  aryVBType(5) = "Currency"         'dbCurrency   =  5
  aryVBType(6) = "Single"           'dbSingle     =  6
  aryVBType(7) = "Double"           'dbDouble     =  7
  aryVBType(8) = "Date"             'dbDate       =  8
  aryVBType(9) = "Binary"           'dbBinary     =  9
  aryVBType(10) = "Text"            'dbText       = 10
  aryVBType(11) = "LongBinary"      'dbLongBinary = 11
  aryVBType(12) = "Memo"            'dbMemo       = 12
  aryVBType(13) = ""                '13 is unknow
  aryVBType(14) = ""                '14 is unknow
  aryVBType(15) = "GUID"            'dbGUID       = 15
  aryVBType(16) = "Bigint"          'dbBigint     = 16
  aryVBType(17) = "VarBinary"       'dbVarBinary  = 17
  aryVBType(18) = "Char"            'dbChar       = 18
  aryVBType(19) = "Numeric"         'dbNumeric    = 19
  aryVBType(20) = "Decimal"         'dbDecimal    = 20
  aryVBType(21) = "Float"           'dbFloat      = 21
  aryVBType(22) = "Time"            'dbTime       = 22
  aryVBType(23) = "TimeStamp"       'dbTIMESTAMP  = 23
  
  '*** ]wDBMakerƫOx} ***
  For i = 1 To DBMakerTypes
    aryDBMSize(i) = 0
  Next i
  aryDBMaker(0) = "Unknow"          'DBMUnkow         =   0
  aryDBMaker(1) = "Binary"          'DBMBinary        =   1
  aryDBMSize(1) = 1
  aryDBMaker(2) = "Char"            'DBMChar          =   2
  aryDBMSize(2) = 1
  aryDBMaker(3) = "Date"            'DBMDate          =   3
  aryDBMaker(4) = "Decimal"         'DBMDecimal       =   4
  aryDBMSize(4) = 2
  aryDBMaker(5) = "Double"          'DBMDouble        =   5
  aryDBMaker(6) = "Float"           'DBMFloat         =   6
  aryDBMaker(7) = "Integer"         'DBMInteger       =   7
  aryDBMaker(8) = "Long Varbinary"  'DBMLongVarbinary =   8
  aryDBMaker(9) = "Long VarChar"    'DBMLongVarChar   =   9
  aryDBMaker(10) = "SmallInt"       'DBMSmallInt      =  10
  aryDBMaker(11) = "Time"           'DBMTime          =  11
  aryDBMaker(12) = "TimeStamp"      'DBMTimeStamp     =  12
  aryDBMaker(13) = "VarChar"        'DBMVarChar       =  13
  aryDBMSize(13) = 1
  
  '*** ]wƫOഫx} ***
  For i = 0 To 23
    aryCvtLen(i) = 0
    aryDot(i) = 0
  Next i
  aryType(1) = DBMSmallInt          'dbBoolean    =  1
  'aryCvtLen(1) = 1
  aryType(2) = DBMSmallInt          'dbByte       =  2
  aryType(3) = DBMSmallInt          'dbInteger    =  3
  aryType(4) = DBMInteger           'dbLong       =  4
  aryType(5) = DBMDecimal           'dbCurrency   =  5
  aryCvtLen(5) = 17
  aryDot(5) = 4
  aryType(6) = DBMFloat             'dbSingle     =  6
  aryType(7) = DBMDouble            'dbDouble     =  7
  aryType(8) = DBMDate              'dbDate       =  8
  aryType(9) = DBMBinary            'dbBinary     =  9
  aryType(10) = DBMVarChar          'dbText       = 10
  aryType(11) = DBMLongVarbinary    'dbLongBinary = 11
  aryType(12) = DBMLongVarChar      'dbMemo       = 12
  aryType(13) = DBMVarChar  'DBMUnknow           '13 is unknow
  aryType(14) = DBMVarChar  'DBMUnknow           '14 is unknow
  aryType(15) = DBMVarChar  'DBMUnknow           'dbGUID       = 15
  aryCvtLen(13) = 255
  aryCvtLen(14) = 255
  aryCvtLen(15) = 255
  aryType(16) = DBMDecimal          'dbBigint     = 16
  aryCvtLen(16) = 17
  aryType(17) = DBMBinary            'dbVarBinary  = 17
  aryType(18) = DBMChar              'dbChar       = 18
  aryType(19) = DBMDouble            'dbNumeric    = 19
  aryType(20) = DBMDecimal           'dbDecimal    = 20
  aryType(21) = DBMFloat             'dbFloat      = 21
  aryType(22) = DBMTime              'dbTime       = 22
  aryType(23) = DBMTimeStamp         'dbTIMESTAMP  = 23
End Sub

Function GetFileName(strFile As String)
  Dim nPos As Integer
  
  nPos = InStr(1, strFile, ".")
  If nPos = 0 Then
    GetFileName = ""
  Else
    GetFileName = Mid(strFile, 1, nPos - 1)
  End If
End Function

Function GetFileSubName(strFile As String) As String
  Dim nPos As Integer
  
  nPos = InStr(1, strFile, ".")
  If nPos = 0 Then
    GetFileSubName = ""
  Else
    GetFileSubName = Mid(strFile, nPos + 1, Len(strFile))
  End If
End Function

Sub SetRcdSource()
  If strFileSubName = "DB" Then
    Set dbSource = dbParadox
  ElseIf strFileSubName = "DBF" Then
    Set dbSource = dbdBase
  ElseIf strFileSubName = "DBC" Then
    Set dbSource = dbVFPDBC
  End If
End Sub

'*********************************
'*    Mapping Relative Action    *
'*********************************
Sub Map_Preparing()
  Dim i As Integer, j As Integer, k As Integer
  Dim nContinue As Integer
  
  '*** Initialize relative arrays
  ReDim aryTableMgr(nTableSel)
  ReDim aryColMgr(0):     aryColMgr(0) = ""
  ReDim aryTypeMgr(0):    aryTypeMgr(0) = 0
  ReDim aryLenMgr(0):     aryLenMgr(0) = 0
  ReDim aryDotMgr(0):     aryDotMgr(0) = 0
  ReDim aryTblColsMgr(0): aryTblColsMgr(0) = 0
  
  On Error Resume Next
  k = -1
  For i = 0 To nTableSel - 1
    Select Case gbDBType
      Case 1     'xBase
        aryTableMgr(i) = GetFileName(aryTableSrc(i))
        strFileSubName = GetFileSubName(aryTableSrc(i))
        SetRcdSource
      Case 2     'Text file
      Case 3     'Access
        aryTableMgr(i) = aryTableSrc(i)
    End Select
    Set rsSource = dbSource.OpenRecordset(aryTableMgr(i))
    ReDim Preserve aryTblColsMgr(i): aryTblColsMgr(i) = rsSource.Fields.Count
    For j = 0 To rsSource.Fields.Count - 1
      k = k + 1
      ReDim Preserve aryColMgr(k)
      ReDim Preserve aryTypeMgr(k)
      ReDim Preserve aryLenMgr(k)
      ReDim Preserve aryDotMgr(k)
      aryColMgr(k) = rsSource.Fields(j).Name
      If rsSource.Fields(j).Type <> dbDate Then
        aryTypeMgr(k) = aryType(rsSource.Fields(j).Type)
      Else
        Set prpSrc = dbSource.TableDefs(aryTableMgr(i)).Fields(j).Properties("format")
        If prpSrc Is Nothing Then
          aryTypeMgr(k) = 3
        Else
          Select Case prpSrc.value
            Case "General Date"
              aryTypeMgr(k) = 12
            Case "Long Date", "Short Date", "Medium Date"
              aryTypeMgr(k) = 3
            Case "Long Time", "Short Time", "Medium Time"
              aryTypeMgr(k) = 11
            Case Else         ' View As "General Date" If Error Happened
              aryTypeMgr(k) = 12
          End Select
        End If
      End If
      If rsSource.Fields(j).Type = dbText Then
        aryLenMgr(k) = rsSource.Fields(j).Size
      Else
        aryLenMgr(k) = aryCvtLen(rsSource.Fields(j).Type)
      End If
      aryDotMgr(k) = aryDot(k)
    Next j
    rsSource.Close
  Next i
End Sub

Sub Map_Table(frmMap As Form)
  Dim i As Integer
  Dim ndTable As Node
  Dim nIdxCount As Integer
  Dim sTableName As String
  
  With frmMap
    nNodes = 0
    For i = 0 To nTableSel - 1
      .tvSource.Nodes.Add , , , aryTableSrc(i), 1, 1
      nNodes = nNodes + 1
      .tvSource.Nodes.Add nNodes, 4, , "", 2, 2
      .tvSource.Nodes(nNodes).Expanded = True
      .tvSource.Nodes(nNodes + 1).Expanded = True
      '** Add Fields Nodes
      nNodes = nNodes + 1
      If gbDBType = 1 Then    'xBase
        strFileSubName = GetFileSubName(aryTableSrc(i))
        SetRcdSource
        sTableName = GetFileName(aryTableSrc(i))
      Else
        sTableName = aryTableSrc(i)
      End If
      With dbSource.TableDefs(sTableName)
        Map_Field frmMap, sTableName
        '** Add Index Nodes
        frmMap.tvSource.Nodes.Add nNodes - .Fields.Count - 1, 4, , "", 3, 3
        nNodes = nNodes + 1
        nIdxCount = Map_Index(frmMap, sTableName)
        '** Add Foreign Key Nodes
        If gbDBType = 3 Then
          frmMap.tvSource.Nodes.Add nNodes - nIdxCount - .Fields.Count - 2, 4, , "~", 4, 4
          nNodes = nNodes + 1
          Map_Foreign frmMap, sTableName
        End If
      End With
    Next i
    .tvSource.Nodes(1).EnsureVisible
  End With
End Sub

Sub Map_Field(frmMap As Form, ByVal sTableName As String)
  Dim fldMap As Field
  
  With dbSource.TableDefs(sTableName)
    For Each fldMap In .Fields
      frmMap.tvSource.Nodes.Add nNodes, 4, , fldMap.Name, 2
    Next
    nNodes = nNodes + .Fields.Count
  End With
End Sub

Function Map_Index(frmMap As Form, ByVal sTableName As String) As Integer
  Dim i As Integer
  Dim idxMap As Index
  Dim fldMap As Field
  Dim sIdxFld As String
  
  On Error Resume Next
  With dbSource.TableDefs(sTableName)
    Map_Index = 0
    For Each idxMap In dbSource.TableDefs(sTableName).Indexes
      If idxMap.Foreign = True Then GoTo Next_Index
      Map_Index = Map_Index + 1
      i = 0
      sIdxFld = idxMap.Name & "("
      For Each fldMap In idxMap.Fields
        If i <> 0 Then sIdxFld = sIdxFld & ", "
        sIdxFld = sIdxFld & fldMap.Name
        i = i + 1
      Next
      sIdxFld = sIdxFld & ")"
      frmMap.tvSource.Nodes.Add nNodes, 4, , sIdxFld, 3
Next_Index:
    Next
    nNodes = nNodes + Map_Index
  End With
End Function

Sub Map_Foreign(frmMap As Form, ByVal sTableName As String)
  Dim i As Integer, j As Integer
  Dim refSrc As Relation
  Dim nCount As Integer
  Dim sRelation As String
  
  nCount = 0
  For Each refSrc In dbSource.Relations
    If refSrc.ForeignTable = sTableName Then
      nCount = nCount + 1
      sRelation = refSrc.Name & "(("
      For j = 0 To refSrc.Fields.Count - 1
        If j <> 0 Then sRelation = sRelation & ", "
        sRelation = sRelation & refSrc.Fields(j).ForeignName
      Next j
      sRelation = sRelation & ") -> " & refSrc.Table & "("
      For j = 0 To refSrc.Fields.Count - 1
        If j <> 0 Then sRelation = sRelation & ", "
        sRelation = sRelation & refSrc.Fields(j).Name
      Next j
      sRelation = sRelation & "))"
      frmMap.tvSource.Nodes.Add nNodes, 4, , sRelation, 4
    End If
  Next
    nNodes = nNodes + nCount
End Sub

'***********************************
'*    Migration Relative Action    *
'***********************************
Sub Mgr_Preparing(frmMgr As Form)
  With frmMgr
    .Left = glPosLeft
    .Top = glPosTop
    .pgbGo.value = 0
    ']wjpΪYe
    With .grdResult
      .ColWidth(0) = 2300
      .ColWidth(1) = 1250
      .ColWidth(2) = 1200
      .ColWidth(3) = 950
      .Rows = nTableSel + 1
      .Row = 0
      .Col = 0: .Text = "                    W          "
      .Col = 1: .Text = "    "
      .Col = 2: .Text = "      "
      .Col = 3: .Text = "       A"
    End With
    .Toolbar1.Buttons(2).Enabled = False
    .Toolbar1.Buttons(3).Enabled = False
    .Toolbar1.Buttons(4).Enabled = False
  End With
End Sub

Sub Mgr_Before(frmMgr As Form)
  With frmMgr
    .Refresh
    .lblMigration.Left = 2565
    .lblMigration.Caption = "ƲतAеyI"
    .lblMigration.Visible = True
  End With
End Sub

Sub Mgr_After(frmMgr As Form)
  With frmMgr
    .pgbGo.value = .pgbGo.Max
    .lblMigration.Left = 2400
    .lblMigration.Caption = "ƲFwg槹I"
    .Toolbar1.Buttons(2).Enabled = True
    .Toolbar1.Buttons(3).Enabled = True
    .Toolbar1.Buttons(4).Enabled = True
    sTextFile = ""
    sFTextFile = ""
    sDelimited = ""
    bFirstRow = False
    gbTextType = False
  End With
End Sub

Sub Mgr_Table(frmMgr As Form, ByVal bSuccess As Boolean, ByVal lRows As Long)
  Dim nTables As Integer
  
  On Error Resume Next
  With frmMgr
    With .grdResult
      .Col = 2: .Text = lRows
      .Col = 3
      If bSuccess Then
        If lRows = lMaxRow Then
          .Text = "       \"
        Else
          .Text = "       "
        End If
      Else
        .Text = "       "
      End If
    End With
  End With
End Sub

Sub Mgr_BtnClick(frmMgr As Form, ByVal Button As ComctlLib.Button)
  Dim nExit As Integer
  
  Select Case Button.Index
    '** Previous **
    Case 1
    '** Next **
    Case 2
      gbODBCOpened = False
      frmMain.Show
      Unload frmMgr
    '** Exit **
    Case 3
      Unload frmMgr
    '** About **
    Case 4
      ShowAbout frmMgr.Left, frmMgr.Top, frmMgr.Width, frmMgr.Height
  End Select
End Sub

Function Mgr_CreateTable(ByVal nIdx As Integer) As Boolean
  Dim dbCreate, strFldSiz As String
  Dim i As Integer, j As Integer, nOPos As Integer
  Dim rsTarget As rdoResultset
  Dim stmt As Long
  Dim dbIndex As String, sTblDef As String
  Dim idxSrc As Index
  Dim fldSrc As Field
  
'  SQLAllocStmt dbTarget.hdbc, stmt
'  SQLSetConnectOption dbTarget.hdbc, 1110, 11
'  SQLSetConnectOption dbTarget.hdbc, 1112, 12
'  SQLSetConnectOption dbTarget.hdbc, 1114, 1
  
  On Error Resume Next
  '*** find the targer table location
  nStart = 0
  nEnd = 0
  For i = 0 To nIdx
    nEnd = nEnd + aryTblColsMgr(i)
    If i <> nIdx Then nStart = nStart + aryTblColsMgr(i)
  Next i
  
  dbTarget.BeginTrans
  '*** table existed ?
  Set rsTarget = dbTarget.OpenResultset("select * from SYSTABLE where TABLE_NAME = '" & aryTableMgr(nIdx) & "'", rdOpenKeyset)
  If rsTarget.RowCount <> 0 Then
    nAction = MsgBox(" " & aryTableMgr(nIdx) & " wsbAO_nNH", vbYesNo + vbQuestion, "N")
    If nAction = vbYes Then
      Err.Clear
      dbTarget.Execute "drop table """ & aryTableMgr(nIdx) & """", rdExecDirect
      If Err.Number <> 0 Then
        MsgBox Err.Description
        Mgr_CreateTable = False
        dbTarget.CommitTrans
        Exit Function
      End If
    Else
      Mgr_CreateTable = False
      dbTarget.CommitTrans
      Exit Function
    End If
  End If
  
  Err.Clear
  '*** create table
  dbCreate = "create table" & " """ & aryTableMgr(nIdx) & """ ("
  For i = nStart To nEnd - 1
    If i <> nStart Then dbCreate = dbCreate & ","
    dbCreate = dbCreate & """" & aryColMgr(i) & """ "
    strFldSiz = aryDBMaker(aryTypeMgr(i))
    Select Case aryDBMSize(aryTypeMgr(i))
      Case 0
      Case 1
        strFldSiz = strFldSiz & "(" & aryLenMgr(i) & ")"
      Case 2
        strFldSiz = strFldSiz & "(" & aryLenMgr(i) & "," & aryDotMgr(i) & ")"
    End Select
    dbCreate = dbCreate & strFldSiz
    Select Case gbDBType
      Case 1                'xBase
        sTblDef = GetFileName(aryTableSrc(nIdx))
      Case Else
        sTblDef = aryTableSrc(nIdx)
    End Select
    If gbDBType <> 2 Then   'Text File
      With dbSource.TableDefs(sTblDef)
        j = i - nStart
        If .Fields(j).Required = True Then
          dbCreate = dbCreate & " Not Null"
        Else
          For Each idxSrc In .Indexes
            If idxSrc.Name = "PrimaryKey" Then
              For Each fldSrc In .Indexes("PrimaryKey").Fields
                If .Fields(j).Name = fldSrc.Name Then dbCreate = dbCreate & " Not Null"
              Next
            End If
          Next
        End If
      End With
    End If
  Next i
  dbCreate = dbCreate & ")"
  dbTarget.Execute dbCreate, rdExecDirect
  dbTarget.CommitTrans
  Select Case Err.Number
    Case 0
      Mgr_CreateTable = True
    Case Else
      MsgBox Err.Description
      Mgr_CreateTable = False
      dbTarget.RollbackTrans
      Exit Function
 End Select
 
  
  'FקKYDEFAULTLkBzӾɭPCREATE TABLEѡAҥHALTER TABLEk
  Mgr_AlterDefault nIdx
   
  On Error Resume Next
  Mgr_CreateTable = True
  For Each idxSrc In dbSource.TableDefs(sTblDef).Indexes
    '*** xBaseӨAPrimaryݩʬTRUEɡAHunique indexBzC
    If idxSrc.Primary = True And gbDBType >= 3 Then
      '*** Create Primary Key ***
      dbIndex = "alter table" & " """ & aryTableMgr(nIdx) & """ primary key ("
      For i = 0 To idxSrc.Fields.Count - 1
        If i <> 0 Then dbIndex = dbIndex & ","
        nOPos = dbSource.TableDefs(sTblDef).Fields(idxSrc.Fields(i).Name).OrdinalPosition
        dbIndex = dbIndex & """" & aryColMgr(nStart + nOPos - 1) & """"
      Next i
      dbIndex = dbIndex & ")"
      dbTarget.Execute dbIndex, rdExecDirect
    ElseIf idxSrc.Foreign = False Then
      '*** Create Index ***
      If gbDBType = 1 Then
        nOPos = dbSource.TableDefs(sTblDef).Fields(idxSrc.Fields(0).Name).OrdinalPosition
      Else
        nOPos = dbSource.TableDefs(sTblDef).Fields(idxSrc.Fields(0).Name).OrdinalPosition - 1
      End If
      If idxSrc.Unique = True Then
        dbIndex = "Create Unique Index"
      Else
        dbIndex = "Create Index"
      End If
      dbIndex = dbIndex & " """ & idxSrc.Name & """ ON " & " """ & aryTableMgr(nIdx) & """"
      dbIndex = dbIndex & "(" & """" & aryColMgr(nStart + nOPos) & """)"
      SQLExecDirect stmt, dbIndex, SQL_NTS
    End If
  Next
  dbTarget.CommitTrans
End Function

Sub Mgr_AlterDefault(nIdx As Integer)
  Dim i As Integer, j As Integer, k As Integer
  Dim stmt As Long
  Dim dbAlter As String, sTblDef As String
  Dim dtX As Date
  Dim strDT As String
  
  SQLAllocStmt dbTarget.hdbc, stmt
  SQLSetConnectOption dbTarget.hdbc, 1110, 11
  SQLSetConnectOption dbTarget.hdbc, 1112, 12
  SQLSetConnectOption dbTarget.hdbc, 1114, 1
  
  Select Case gbDBType
    Case 1               'xBase
      sTblDef = GetFileName(aryTableSrc(nIdx))
    Case Else
      sTblDef = aryTableSrc(nIdx)
  End Select
  On Error Resume Next
  For i = nStart To nEnd - 1
    j = i - nStart
    With dbSource.TableDefs(sTblDef)
      If .Fields(j).DefaultValue <> "" Then
        dbAlter = "Alter Table" & " """ & aryTableMgr(nIdx) & """ Modify (" _
                & """" & .Fields(j).Name & """" & " Default To "
        If .Fields(j).Type = dbText Then
          k = Len(.Fields(j).DefaultValue)
          dbAlter = dbAlter & "'" & Mid(.Fields(j).DefaultValue, 2, k - 2) & "'"
        ElseIf .Fields(j).Type <> dbDate Then
          dbAlter = dbAlter & .Fields(j).DefaultValue
        Else
          Select Case .Fields(j).Properties("format")
            Case "General Date"
              strDT = Mid(.Fields(j).DefaultValue, 2, Len(.Fields(j).DefaultValue) - 2)
              dtX = Format(strDT, "yyyy/mm/dd hh:mm:ss")
              strDT = Format(dtX, "yyyy/mm/dd hh:mm:ss")
            Case "Long Date", "Medium Date", "Short Date"
              strDT = Mid(.Fields(j).DefaultValue, 2, Len(.Fields(j).DefaultValue) - 2)
              dtX = Format(strDT, "yyyy/mm/dd")
              strDT = Format(dtX, "yyyy/mm/dd")
            Case Else
              strDT = Mid(.Fields(j).DefaultValue, 2, Len(.Fields(j).DefaultValue) - 2)
              dtX = Format(strDT, "hh:mm:ss")
              strDT = Format(dtX, "hh:mm:ss")
          End Select
          dbAlter = dbAlter & "'" & strDT & "'"
        End If
        dbAlter = dbAlter & ")"
        SQLExecDirect stmt, dbAlter, SQL_NTS
      End If
    End With
  Next i
  SQLFreeStmt stmt, SQL_DROP
End Sub

Sub Mgr_InsertData(frmMgr As Form, nIdx As Integer)
  Dim i As Long, j As Integer, k As Integer, l As Integer, m As Integer
  Dim x As Integer, y As Integer
  Dim strTemp As String
  Dim dbInsert As String
  Dim dbStr As String
  Dim bErrorTwice As Boolean
  Dim stmt As Long
  Dim SQLError As Integer
  Dim strDT As String
  Dim dtX As Date

  frmMgr.pgbGo.Min = 0
  frmMgr.pgbGo.Max = rsSource.RecordCount
  frmMgr.pgbGo.value = 0
  
  SQLAllocStmt dbTarget.hdbc, stmt
  SQLSetConnectOption dbTarget.hdbc, 1110, 11
  SQLSetConnectOption dbTarget.hdbc, 1112, 12
  SQLSetConnectOption dbTarget.hdbc, 1114, 1
  dbTarget.BeginTrans
  rsSource.MoveFirst
  On Error Resume Next
  
  i = 0
  rsSource.MoveFirst
  While Not rsSource.EOF
    i = i + 1
    Err.Clear
    bErrorTwice = False
    dbInsert = "insert into " & aryTableMgr(nIdx) & " values("
    For j = 0 To rsSource.Fields.Count - 1
      l = j + nStart
      If j <> 0 Then dbInsert = dbInsert & ","
      If IsNull(rsSource.Fields(j).value) Then
        dbInsert = dbInsert & vbNullString
      ElseIf rsSource.Fields(j).Type = dbBoolean Then
        If rsSource.Fields(j).value = True Then
          If aryTypeMgr(l) = DBMDecimal Or _
             aryTypeMgr(l) = DBMDouble Or _
             aryTypeMgr(l) = DBMFloat Or _
             aryTypeMgr(l) = DBMInteger Or _
             aryTypeMgr(l) = DBMSmallInt Then
            dbInsert = dbInsert & "1"
          Else
            dbInsert = dbInsert & " '" & "T" & "'"
          End If
        Else
          If aryTypeMgr(l) = DBMDecimal Or _
             aryTypeMgr(l) = DBMDouble Or _
             aryTypeMgr(l) = DBMFloat Or _
             aryTypeMgr(l) = DBMInteger Or _
             aryTypeMgr(l) = DBMSmallInt Then
            dbInsert = dbInsert & "0"
          Else
            dbInsert = dbInsert & " '" & "F" & "'"
          End If
        End If
      ElseIf aryTypeMgr(l) = DBMDecimal Or _
             aryTypeMgr(l) = DBMDouble Or _
             aryTypeMgr(l) = DBMFloat Or _
             aryTypeMgr(l) = DBMInteger Or _
             aryTypeMgr(l) = DBMSmallInt Then
        dbInsert = dbInsert & " " & rsSource.Fields(j).value
      ElseIf rsSource.Fields(j).Type = dbLongBinary Or _
             rsSource.Fields(j).Type = dbMemo Then
        dbInsert = dbInsert & " '" & rsSource.Fields(j).value & "'"
      ElseIf rsSource.Fields(j).Type = dbDate Or _
             rsSource.Fields(j).Type = dbTime Or _
             rsSource.Fields(j).Type = dbTimeStamp Then
        Select Case aryTypeMgr(l)
          Case DBMTimeStamp
            dtX = Format(rsSource.Fields(j).value, "yyyy-mm-dd hh:mm:ss")
            strDT = Format(dtX, "yyyy-mm-dd hh:mm:ss")
          Case DBMDate
            dtX = Format(rsSource.Fields(j).value, "yyyy-mm-dd")
            strDT = Format(dtX, "yyyy-mm-dd")
          Case DBMTime
            dtX = Format(rsSource.Fields(j).value, "hh:mm:ss")
            strDT = Format(dtX, "hh:mm:ss")
        End Select
        dbInsert = dbInsert & " '" & strDT & "'"
      Else
        k = InStr(1, rsSource.Fields(j).value, "'", 1)
        If k = 0 Then
          dbInsert = dbInsert & " '" & rsSource.Fields(j).value & "'"
        Else
          dbStr = CheckStr(rsSource.Fields(j).value)
          dbInsert = dbInsert & " '" & dbStr & "'"
        End If
      End If
    Next j
    dbInsert = dbInsert & ")"
    SQLError = SQLExecDirect(stmt, dbInsert, SQL_NTS)
    If SQLError < 0 Then
      strTemp = ""
      For x = 1 To Len(dbInsert)
        y = Asc(Mid(dbInsert, x, 1))
        If y <> 0 Then strTemp = strTemp & Mid(dbInsert, x, 1)
      Next x
      dbInsert = strTemp
      SQLError = SQLExecDirect(stmt, dbInsert, SQL_NTS)
      If SQLError = 0 Then GoTo Insert_Success
      nAction = MsgBox("O_~H", vbYesNo + vbQuestion, "" & rsSource.Name & "ƿ~")
      If nAction = vbNo Then
        bSuccess = False
        dbTarget.CommitTrans
        Exit Sub
      Else
        Err.Clear
      End If
    Else
Insert_Success:
      lRows = lRows + 1
    End If
    frmMgr.grdResult.Col = 2: frmMgr.grdResult.Text = i
    frmMgr.pgbGo.value = i
    frmMgr.Refresh
    If (i Mod 500) = 0 Then
      dbTarget.CommitTrans
      dbTarget.BeginTrans
    End If
    rsSource.MoveNext
  Wend
  SQLFreeStmt stmt, SQL_DROP
  dbTarget.CommitTrans
End Sub

Function CheckStr(strValue As String)
  Dim i As Integer
  Dim strChar As String
  
  CheckStr = ""
  For i = 1 To Len(strValue)
    strChar = Mid(strValue, i, 1)
    If strChar = "'" Then
      CheckStr = CheckStr & "''"
    Else
      CheckStr = CheckStr & strChar
    End If
  Next i
End Function

Sub Mgr_AlterFK()
  Dim tbSrc As TableDef
  Dim rlSrc As Relation
  Dim nTables As Integer
  Dim nRefTbl As Integer, nRefCol As Integer, nBaseTbl As Integer, nBaseCol As Integer
  Dim dbForeign As String
  Dim stmt As Long
  Dim i As Integer
  
  On Error Resume Next
  For Each rlSrc In dbSource.Relations
    If Not (GetTblSeq(rlSrc.ForeignTable, nRefTbl, nRefCol) And GetTblSeq(rlSrc.Table, nBaseTbl, nBaseCol)) Then GoTo NextForeign
    dbForeign = "alter table " & aryTableMgr(nRefTbl) & " foreign key " & rlSrc.Name & " ("
    For i = 0 To rlSrc.Fields.Count - 1
      If i <> 0 Then dbForeign = dbForeign & ","
      dbForeign = dbForeign & _
                  aryColMgr(dbSource.TableDefs(aryTableSrc(nRefTbl)).Fields(rlSrc.Fields(i).ForeignName).OrdinalPosition + nRefCol - 1)
    Next i
    dbForeign = dbForeign & ") references " & aryTableMgr(nBaseTbl) & "("
    For i = 0 To rlSrc.Fields.Count - 1
      If i <> 0 Then dbForeign = dbForeign & ","
      dbForeign = dbForeign & _
                  aryColMgr(dbSource.TableDefs(aryTableSrc(nBaseTbl)).Fields(rlSrc.Fields(i).Name).OrdinalPosition + nBaseCol - 1)
    Next i
    dbForeign = dbForeign & ")"
    SQLAllocStmt dbTarget.hdbc, stmt
    SQLExecDirect stmt, dbForeign, SQL_NTS
NextForeign:
  Next
End Sub

Function GetTblSeq(ByVal strTblSrc As String, nTblPos As Integer, nStartColPos As Integer) As Boolean
  Dim nTables As Integer, nCols As Integer
  
  GetTblSeq = False
  nTblPos = -1
  nStartColPos = 0
  For nTables = 0 To nTableSel - 1
    nTblPos = nTblPos + 1
    If aryTableSrc(nTables) = strTblSrc Then
      GetTblSeq = True
      Exit For
    End If
    nStartColPos = nStartColPos + dbSource.TableDefs(aryTableSrc(nTables)).Fields.Count
  Next nTables
End Function




